/* flattypelist.hh
 * This file belongs to Worker, a filemanager for UNIX/X11.
 * Copyright (C) 2006 Ralf Hoffmann.
 * You can contact me at: ralf@boomerangsworld.de
 *   or http://www.boomerangsworld.de/worker
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef FLATTYPELIST_HH
#define FLATTYPELIST_HH

#include "wdefines.h"
#include <vector>
#include <list>
#include <string>

class WCFiletype;
class FieldListView;
class List;

namespace FlatTypeList {
  typedef struct {
    WCFiletype *filetype;
    int depth;
  } flattypelist_t;
  void addSubTypes( std::vector<flattypelist_t> *l1,
		    const std::list<WCFiletype*> *types, int depth );
  std::vector<flattypelist_t> *getFlatTypeList( List *types );
  std::string getStringForName( flattypelist_t &type );
  void buildLV( FieldListView *lv,
                std::vector<flattypelist_t> *l1,
                WCFiletype *highlightft );
};

#endif
